
;#########################################################################
;
;Modified and Extended By Elias Tsiantas - elias_t [25/6/03]
;Particle system based on simon@acid's single surface particle system
;uses tris instead of quads
;
;#########################################################################




Include "ssps.bb";the psys


Include "data.bb";read the data for the 16 emitters in the scene




;Frame limiting code setup 
Global gameFPS 		= 50 
Global framePeriod 	= 1000 / gameFPS 
Global frameTime 	= MilliSecs () - framePeriod 
Global frameTween#  = 1.0


;camera globals
Global FL_Pitch#,FL_Yaw#,FL_Roll#
Global FL_XSpeed#,FL_YSpeed#,FL_ZSpeed#
Global speed#=0.18



Graphics3D 640,480,32,2



HidePointer

camera=CreateCamera()
CameraClsColor camera,50,50,50
PositionEntity camera,0,100,-200
MoveMouse GraphicsWidth()/2,GraphicsHeight()/2

li=CreateLight()

;make 3 rooms
cube=CreateCube()
FlipMesh cube
UpdateNormals cube
tex=LoadTexture("smoke.bmp",48)
EntityTexture cube,tex
ScaleEntity cube,100,100,100
MoveEntity cube,0,100,0

cube=CreateCube()
FlipMesh cube
UpdateNormals cube
EntityTexture cube,tex
ScaleEntity cube,100,100,100
MoveEntity cube,-250,100,0

cube=CreateCube()
FlipMesh cube
UpdateNormals cube
EntityTexture cube,tex
ScaleEntity cube,100,100,100
MoveEntity cube,250,100,0

FreeTexture tex






;create the emitters based on the data read of the data.bb file

;~~~~~~~~~~~~~~

PH_make_emitters()

;~~~~~~~~~~~~~~



;MAIN LOOP

While Not KeyHit(1)


	; Frame limiting 
	Repeat 
		frameElapsed = MilliSecs () - frameTime 
	Until frameElapsed 
	frameTicks = frameElapsed / framePeriod 
	frameTween# = Float (frameElapsed Mod framePeriod) / Float (framePeriod) 

	
	; Update game and world state 
	For frameLimit = 1 To frameTicks 
		If frameLimit = frameTicks Then CaptureWorld 
		frameTime = frameTime + framePeriod 

		
		UpdateWorld
		
		;
		;add and update particles
		PH_add_particles()
		PH_update_particles(camera)
		;
		
FreeLook (camera)


	Next


				
 	RenderWorld frameTween

	
	;
	
	

	
	;make anm emitter alive for 5 seconds with [id=20]
	If MouseDown(1)
	FlushMouse()
	;check to see if this emitter [id=20] exists
	For em.emitter=Each emitter
	If em\id=20
	flag=1
	Else
	flag=0
	EndIf
	Next
	If flag=0 Gosub add_emitter
	EndIf
	
	
	
	Text 10,0,"wsadrf=move , mouse=look"
	Text 10,14,"tris:"+TrisRendered()
	Text 10,28,"fps :"+fps2+"  framelimit fps: "+gameFPS
	Text 10,42,"[F1] = Show Status"
	
	;fps
	fps=fps+1
	If fps_t<MilliSecs()
	fps2=fps
	fps_t=1000+MilliSecs()
	fps=0
	EndIf


If KeyDown(59) emitter_status();[F1]





	Flip 0
		
Wend

;destroy the emitters
Destroy_all_particles()

ClearWorld
EndGraphics
End











;/////////////////////////////////////////////////////////////////////////

;
.add_emitter
;green smoke
;read data
em.emitter=New emitter
em\id=20
em\tris=128;
em\tex$="smoke.bmp"
em\texflag=2+16+32
em\fx=3
em\blend=3
em\alpha=1.0
em\vrange=300.0
em\r=255:em\g=255:em\b=255
em\gravity=0.003
em\updtrate=0
em\size=9.0;
em\x=18.0:em\y=20.0:em\z=20.0
em\vsize=0.01
em\vx1=-.5
em\vx2=.5
em\vy1=3.35
em\vy2=2.4
em\vz1=-.5
em\vz2=.5
em\rgb=$00eeff
em\cycles=600

em\emitterlife=5000+MilliSecs();5 seconds of life for this emitter

;And make the point emitter
em\hndl=CreateDirt(em\id,em\x,em\y,em\z,em\tris,em\tex$,em\texflag,em\fx,em\blend,em\alpha,em\vrange,em\r,em\g,em\b,em\gravity,em\updtrate)

Return












;/////////////////////////////////////////////////////////////////////////

Function emitter_status()

Color 255,255,0
Text 10,60,"Emitters alive: "+PH_Emitters_alive()
Text 10,75,"Emitters hidden: "+PH_Emitters_hidden()
Text 10,90,"Emitters shown: "+PH_Emitters_shown()
Color 255,255,255

End Function






Function FreeLook(FL_Cam)

FL_Pitch#=FL_Pitch#-(MouseYSpeed()*0.02)
FL_Pitch#=FL_Pitch#/1.2
FL_Yaw#=FL_Yaw#+-(MouseXSpeed()*0.02)
FL_Yaw#=FL_Yaw#/1.2
MoveMouse (GraphicsWidth()/2,GraphicsHeight()/2)
FL_ZSpeed#=FL_ZSpeed#+Float(KeyDown(17)-KeyDown(31))*speed# ; W & S
FL_ZSpeed#=FL_ZSpeed#/1.14
FL_XSpeed#=FL_XSpeed#+Float(KeyDown(32)-KeyDown(30))*speed# ; A & D
FL_XSpeed#=FL_XSpeed#/1.14
FL_YSpeed#=FL_YSpeed#+Float(KeyDown(19)-KeyDown(33))*speed# ; R & F
FL_YSpeed#=FL_YSpeed#/1.14
FL_Roll#=(FL_Yaw#*speed#)-(FL_XSpeed#*1.7)
MoveEntity FL_Cam,FL_XSpeed#,FL_YSpeed#+Abs(FL_Roll#*FL_XSpeed#)/50,FL_ZSpeed#
Local cp#=EntityPitch(FL_Cam,True)+FL_Pitch#
If cp<-89 Then cp=-89
If cp>89 Then cp=89
RotateEntity FL_Cam,cp,EntityYaw(FL_Cam)+FL_Yaw#,FL_Roll#

End Function
;-------------------